//+------------------------------------------------------------------+
//|                                      Check_PathFunctions.dll.mq4 |
//|                                      Copyright  Zhunko          |
//| 08.06.2011 - 09.02.2014              vadim@zhunko.ru             |
//+------------------------------------------------------------------+
//|        Windows Vista  .|
//+------------------------------------------------------------------+
#property copyright "Copyright  Zhunko"
#property link      "vadim@zhunko.ru"
#property show_inputs
#include <PathFunctions.mqh> //    "PathFunctions.dll"     .
//
input string PathTest       = "F:\\Check_PathFunctions\\Test0"; //   .      .
input string PathSymbLink   = "F:\\Check_SymbolicLink\\Test0";  //    .      .
input bool   CheckAll       = false;                            //    .
input bool   Check          = false;                            //  1.     PathCheck().
input bool   ClearContents  = false;                            //  2.     PathClearContents().
input bool   ClearFromFiles = false;                            //  3.     PathClearFromFiles().
input bool   Copy           = false;                            //  4.     PathCopy().
input bool   Create         = false;                            //  5.     PathCreate().
input bool   Delete         = false;                            //  6.     PathDelete().
input bool   GetList        = false;                            //  7.         PathGetList().
input bool   IsEmpty        = false;                            //  8.      PathEmpty().
input bool   Move           = false;                            // 10.     PathMove().
input bool   SymbolicLink   = false;                            // 11.        PathSymbolicLink().
input bool   TrimNameFile   = false;                            // 12.           PathTrimNameFile().
//
void OnStart()
 {
  bool   bResult = false; //   .
  int    i = 0;
  int    nSize = 0;       //  .
  string sComment = "";
  string sFileName = "C:\\Check_PathFunctions\\Test\\Test1\\Test2\\Test3\\Test4\\Text.txt";
  string amsList[100]; //       .
  //=======================================================================================================================================================================================================================================
  // 1.    .   ,   TRUE,  - FALSE.
  if (CheckAll || Check)
   {
    sComment = sComment + StringConcatenate("1.  PathCheckW(\"", PathTest, "\") = ", PathCheckW(PathTest), ";\n    PathCheckW(\"", TerminalPath(), "\") = ", PathCheckW(TerminalPath()), ";\n\n"); //  .
    Comment(sComment);
   }
  //=======================================================================================================================================================================================================================================
  // 2-4.    ,    .   ,    .     .      .
  if (CheckAll || Copy || ClearContents || ClearFromFiles)
   {
    sComment = sComment + StringConcatenate("4.    \"", TerminalPath(), "\\MQL4\\Scripts\"  \"", TerminalPath(), "\\Test\".\n");
    Comment(sComment);
    sComment = sComment + "     PathCopyW() = " + PathCopyW(TerminalPath() + "\\MQL4\\Scripts", TerminalPath() + "\\Test") + ";\n"; // .
    Comment(sComment);
    sComment = sComment + StringConcatenate("     PathCheckW(\"", TerminalPath(), "\\Test\") = ", PathCheckW(TerminalPath() + "\\Test"), ";\n"); //  .
    sComment = sComment + "       30 ,   ,     4     .\n\n"; //  .
    Comment(sComment);
    Sleep(30000);
    if (ClearContents)
     {
      sComment = sComment + StringConcatenate("2.    \"", TerminalPath(), "\\Test\"   .\n");
      Comment(sComment);
      sComment = sComment + "     PathClearContentsW() = " + PathClearContentsW(TerminalPath() + "\\Test") + ";\n"; // .
      Comment(sComment);
      sComment = sComment + "       30 ,   ,     4     .\n\n"; //  .
      Comment(sComment);
      Sleep(30000);
     }
    if (ClearFromFiles)
     {
      sComment = sComment + StringConcatenate("3.    \"", TerminalPath(), "\\Test\"  .\n");
      Comment(sComment);
      sComment = sComment + "     PathClearFromFilesW() = " + PathClearFromFilesW(TerminalPath() + "\\Test") + ";\n"; // .
      Comment(sComment);
      sComment = sComment + "       30 ,   ,     4     .\n\n"; //  .
      Comment(sComment);
      Sleep(30000);
     }
    bResult = PathDeleteW(TerminalPath() + "\\Test");
    sComment = sComment + StringConcatenate("     PathDeleteW(", TerminalPath(), "\\Test\") = ", bResult, ";\n\n"); //  .
    Comment(sComment);
   }
  //=======================================================================================================================================================================================================================================
  // 5.   .
  if (CheckAll || Create || Delete)
   {
    sComment = sComment + StringConcatenate("5.    \"", TerminalPath(), "\\Test\\Test1\\Test2\\Test3\".\n");
    Comment(sComment);
    bResult = PathCreateW(TerminalPath() + "\\Test\\Test1\\Test2\\Test3"); //    .
    sComment = sComment + "     PathCreateW() = " + bResult + ";\n"; // .
    Comment(sComment);
    sComment = sComment + StringConcatenate("     PathCheckW(\"", TerminalPath(), "\\Test\\Test1\\Test2\\Test3\") = ", PathCheckW(TerminalPath() + "\\Test\\Test1\\Test2\\Test3"), ";\n\n"); //  .
    Comment(sComment);
   }
  //=======================================================================================================================================================================================================================================
  // 6-7.   .   ,   TRUE,  - FALSE.
  if (CheckAll || Delete || Create)
   {
    sComment = sComment + StringConcatenate("6.    \"", TerminalPath(), "\\Test\\Test1\\Test2\\Test3\"\n");
    sComment = sComment + "       30 ,   ,     4     .\n";
    Comment(sComment);
    Sleep(30000);
    bResult = PathDeleteEmptyW(TerminalPath() + "\\Test\\Test1\\Test2\\Test3");
    sComment = sComment + StringConcatenate("    PathDeleteEmptyW(", TerminalPath(), "\\Test\\Test1\\Test2\\Test3\") = ", bResult, ";\n"); //  .
    sComment = sComment + "       30 ,   ,     4     .\n";
    Comment(sComment);
    Sleep(30000);
    sComment = sComment + StringConcatenate("     PathCheckW(\"", TerminalPath(), "\\Test\\Test1\\Test2\\Test3\") = ", PathCheckW(TerminalPath() + "\\Test\\Test1\\Test2\\Test3"), ";\n\n"); //  .
    Comment(sComment);
    if (!bResult) //    ,    "PathDelete()".
     {
      bResult = PathDeleteW(TerminalPath() + "\\Test\\Test1\\Test2\\Test3");
      sComment = sComment + StringConcatenate("     PathDeleteW(", TerminalPath(), "\\Test\\Test1\\Test2\\Test3\") = ", bResult, ";\n"); //  .
      Comment(sComment);
      sComment = sComment + StringConcatenate("     PathCheckW(\"", TerminalPath(), "\\Test\\Test1\\Test2\\Test3\") = ", PathCheckW(TerminalPath() + "\\Test\\Test1\\Test2\\Test3"), ";\n"); //  .
      Comment(sComment);
     }
    sComment = sComment + StringConcatenate("7.     \"", TerminalPath(), "\\Test\"\n");
    Comment(sComment);
    bResult = PathDeleteW(TerminalPath() + "\\Test");
    sComment = sComment + StringConcatenate("     PathDeleteW(", TerminalPath(), "\\Test\") = ", bResult, ";\n"); //  .
    Comment(sComment);
    sComment = sComment + StringConcatenate("     PathCheckW(\"", TerminalPath(), "\\Test\") = ", PathCheckW(TerminalPath() + "\\Test"), ";\n\n"); //  .
    Comment(sComment);
   }
  //=======================================================================================================================================================================================================================================
  // 8.     /          .      / .         -1.
  if (CheckAll || GetList)
   {//   .
    sComment = sComment + "8.         .\n\n";
    Comment(sComment);
    for (i = 0; i < 100; i++) amsList[i] = i + "                                                                                                    "; //  .
    nSize = PathGetListMW(TerminalPath() + "\\*.*", //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                                    //   ,         .      ,
                                                    //    ,               .
                          GL_FOLDER,                //  : GL_FOLDER -   .
                                                    //               GL_FILE   -   .
                                                    //               GL_ALL    -    .
                          amsList,                  //         .             .
                          ArraySize(amsList));      //       .
    Alert("8.1. ====   ====");
    for (i = 0; i < 100 && i < nSize; i++) Alert(i, "   \"", amsList[i], "\""); //   .
    //   .
    for (i = 0; i < 100; i++) amsList[i] = i + "                                                                                                    "; //  .
    nSize = PathGetListMW(TerminalPath() + "\\*.*", //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                                    //   ,         .      ,
                                                    //    ,               .
                          GL_FILE,                  //  : GL_FOLDER -   .
                                                    //               GL_FILE   -   .
                                                    //               GL_ALL    -    .
                          amsList,                  //         .             .
                          ArraySize(amsList));      //       .
    Alert("8.2. ====   ====");
    for (i = 0; i < 100 && i < nSize; i++) Alert(i, "   \"", amsList[i], "\""); //   .
    //     .
    for (i = 0; i < 100; i++) amsList[i] = i + "                                                                                                    "; //  .
    nSize = PathGetListMW(TerminalPath() + "\\*.*", //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                                    //   ,         .      ,
                                                    //    ,               .
                          GL_ALL,                   //  : GL_FOLDER -   .
                                                    //               GL_FILE   -   .
                                                    //               GL_ALL    -    .
                          amsList,                  //         .             .
                          ArraySize(amsList));      //       .
    Alert("8.3. ====     ====");
    for (i = 0; i < 100 && i < nSize; i++) Alert(i, "   \"", amsList[i], "\""); //     .
    Sleep(30000);
   }
  //=======================================================================================================================================================================================================================================
  // 9.     .   TRUE,      FALSE,         .
  if (CheckAll || IsEmpty)
   {
    PathCreateW(TerminalPath() + "\\Test\\Test1"); //    .       .
    bResult = PathIsEmptyW(TerminalPath());
    sComment = sComment + StringConcatenate("9.     : PathIsEmptyW(\"", TerminalPath(), "\") = ", bResult, "\".\n");
    Comment(sComment);
    bResult = PathIsEmptyW(TerminalPath() + "\\Test\\Test1");
    sComment = sComment + StringConcatenate("        : PathIsEmptyW(\"", TerminalPath(), "\\Test\\Test1\") = ", bResult, "\".\n");
    Comment(sComment);
    bResult = PathIsEmptyW(TerminalPath() + "\\Test");
    sComment = sComment + StringConcatenate("        : PathIsEmptyW(\"", TerminalPath(), "\\Test\") = ", bResult, "\".\n");
    sComment = sComment + "       30 ,   ,     4     .\n";
    Comment(sComment);
    Sleep(30000);
    PathDeleteW(TerminalPath() + "\\Test"); //   .
    sComment = sComment + StringConcatenate("     PathCheckW(\"", TerminalPath() + "\\Test\") = ", PathCheckW(TerminalPath() + "\\Test"), ";\n\n"); //  .
    Comment(sComment);
   }
  //=======================================================================================================================================================================================================================================
  //10.   ()  ,    .   ,      .      .
  if (CheckAll || Move)
   {
    PathCreateW(TerminalPath() + "\\Test\\Test1"); //    .       .
    sComment = sComment + StringConcatenate("10.     \"", TerminalPath(), "\\Test\\Test1\"  \"", PathTest, "\".\n");
    Comment(sComment);
    sComment = sComment + "    PathMove() = " + PathMoveW(TerminalPath() + "\\Test\\Test1", PathTest) + "\n";
    sComment = sComment + StringConcatenate("    PathCheckW(\"", TerminalPath() + "\\Test\\Test1", "\") = ", PathCheckW(TerminalPath() + "\\Test\\Test1"), ";\n"); //  .
    sComment = sComment + StringConcatenate("    PathCheckW(\"", PathTest, "\") = ", PathCheckW(PathTest), ";\n"); //  .
    sComment = sComment + "      30 ,   ,     4     .\n\n"; //  .
    Comment(sComment);
    Sleep(30000);
    sComment = sComment + StringConcatenate("         \"", PathTest, "\"  \"", TerminalPath(), "\\Test\\Test1\".\n");
    Comment(sComment);
    sComment = sComment + "    PathMoveW() = " + PathMoveW(PathTest, TerminalPath() + "\\Test\\Test1") + "\n";
    sComment = sComment + StringConcatenate("    PathCheckW(\"", PathTest, "\") = ", PathCheckW(PathTest), ";\n"); //  .
    sComment = sComment + StringConcatenate("    PathCheckW(\"", TerminalPath() + "\\Test\\Test1", "\") = ", PathCheckW(TerminalPath() + "\\Test\\Test1"), ";\n"); //  .
    sComment = sComment + "      30 ,   ,     4     .\n\n"; //  .
    Comment(sComment);
    Sleep(30000);
    string sPathTest = PathTrimNameFileW(PathTest);
    sComment = sComment + StringConcatenate("        \"", sPathTest, "\".\n"); //    .
    bResult = PathDeleteW(sPathTest); //   .
    sComment = sComment + StringConcatenate("    PathDeleteW(\"", sPathTest, "\") = ", bResult, ";\n"); //  .
    Comment(sComment);
    sComment = sComment + StringConcatenate("    PathCheckW(\"", sPathTest, "\") = ", PathCheckW(sPathTest), ";\n\n"); //  .
    
    sComment = sComment + StringConcatenate("        \"", TerminalPath(), "\\Test\".\n"); //    .
    bResult = PathDeleteW(TerminalPath() + "\\Test"); //   .
    sComment = sComment + StringConcatenate("    PathDeleteW(\"", TerminalPath(), "\\Test\") = ", bResult, ";\n"); //  .
    Comment(sComment);
    sComment = sComment + StringConcatenate("    PathCheckW(\"", TerminalPath() + "\\Test\") = ", PathCheckW(TerminalPath() + "\\Test"), ";\n\n"); //  .
    Comment(sComment);
   }
  //=======================================================================================================================================================================================================================================
  //11.       .    ,   TRUE,  - FALSE.      .
  if (CheckAll || SymbolicLink)
   {
    sComment = sComment + StringConcatenate("11.      \"", TerminalPath(), "\\MQL4\\Logs\"  \"", PathSymbLink, "\".\n");
    Comment(sComment);
    sComment = sComment + StringConcatenate("    PathSymbolicLinkW() = ", PathSymbolicLinkW(TerminalPath() + "\\MQL4\\Logs", PathSymbLink), ";\n"); //     .
    Comment(sComment);
    sComment = sComment + StringConcatenate("    PathCheckW(\"", PathSymbLink, "\") = ", PathCheckW(PathSymbLink), ";\n"); //  .
    sComment = sComment + "      30 ,   ,     4     .\n"; //  .
    Comment(sComment);
    Sleep(30000);
    bResult = PathDeleteW(PathTrimNameFileW(PathSymbLink));
    sComment = sComment + StringConcatenate("    PathDeleteW(\"", PathSymbLink, "\") = ", bResult, ";\n"); //  .
    Comment(sComment);
    sComment = sComment + StringConcatenate("    PathCheckW(\"", PathSymbLink, "\") = ", PathCheckW(PathSymbLink), ";\n\n"); //  .
    Comment(sComment);
   }
  //=======================================================================================================================================================================================================================================
  //12.                  ,   .       .
  //        ,          .           ,   ,    ,   .
  if (CheckAll || TrimNameFile)
   {
    sComment = sComment + StringConcatenate("12.           \"", sFileName, "\".\n            .");
    Comment(sComment);
    Alert("10.           \"", sFileName, "\"");
    for (i = 0; i < 7; i++) Alert(i, "   \"", PathTrimNameFileW(sFileName), "\"");
   }
  //=======================================================================================================================================================================================================================================
 }
//